function [tmesh, H, dHu] = Hamiltonian(solM,solC,u,S,I,par)
%HAMILTONIAN - function calculating Hamiltonian value and value of its
%derivative with respect to control u

H=NaN; %no need to calculate in this version of the code
    
tmesh=unique([solM.x solC.x]);
solMm=deval(solM,tmesh);
solCc=deval(solC,tmesh);
    
if par.angType
    dHu=par.k1-par.l./(par.a+control(tmesh,u)).^2.*solCc(2,:).*feval(S,solMm(1,:),solMm(2,:));
else
    dHu=par.k1-par.e*solCc(2,:).*solMm(2,:);
end
    
    
end

