function [l1, uN] = findOpt(u,dHu,tmesh,S,I,par, init)
%FINDOPT - function finding the best value by which multiply the
%Hamiltonians derivative and add to control.
    
    %%%% creating common mesh and taking values
    tmeshN=unique([u.ti tmesh]);
    uN=interp1(u.ti,u.ui,tmeshN);
    dHuN=interp1(tmesh,dHu,tmeshN);
    
    u.ti=tmeshN;
    u.ui=uN;
    
    %%%%
    
    for i=1:10
        l1=abs(fminsearch(@F,i));
        if F(l1)<F(0)
            uN=u;
            uN.ui=min(max(u.ui-l1*dHuN,par.Lb),par.Ub);
            break;
        end
    end
    
    if F(l1)>=F(0)
        l1=0;
        uN=u;
    end
    
    function y=F(x)
        ux=u;
        ux.ui=min(max(u.ui-abs(x)*dHuN,par.Lb),par.Ub);
        solM=solveModel( S, I, ux, par, init);
        y=payoff(solM.y(1,end), solM.y(2,end), ux, par);
    end

end

