function [x0, val, uout] = findOptShooting( S, I, dS, dI, par, init, u )
%FINDOPTSHOOTING - function approximating the optimal control using
%shooting method.

    solMinit=solveModel( S,I,u, par, init);
    solCinit=solveCostateInv(solMinit,u, dS, dI, par);
    
    initC=deval(solCinit,0);
    
    options=optimset('Display','iter','TolX',1e-10,'TolFun',1e-10);
    [x0, val]=lsqnonlin(@F, initC,[],[],options);
    
    [~, uout]=F(x0);
    
    function [y, u]=F(x)
        
        solM=solveFullSystem( S,I, dS, dI, par, [init; x]);
        
        u.ti=solM.x;
        u.ui=solveHu(solM.x,solM.y,S,par);
        
        [~,bound]=payoff(solM.y(1,end),solM.y(2,end),u,par);
       
        y=solM.y(3:4,end)-bound;
    end
end

